/* A Bison parser, made by GNU Bison 3.0.5.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018 Free Software Foundation, Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "3.0.5"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 1

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1


/* Substitute the variable and function names.  */
#define yyparse         parser_parse
#define yylex           parser_lex
#define yyerror         parser_error
#define yydebug         parser_debug
#define yynerrs         parser_nerrs


/* Copy the first part of user declarations.  */
#line 19 "parser.y" /* yacc.c:339  */


#include "vbscript.h"
#include "parse.h"

#include "wine/debug.h"

WINE_DEFAULT_DEBUG_CHANNEL(vbscript);

static int parser_error(parser_ctx_t *,const char*);

static void parse_complete(parser_ctx_t*,BOOL);

static void source_add_statement(parser_ctx_t*,statement_t*);
static void source_add_class(parser_ctx_t*,class_decl_t*);

static void *new_expression(parser_ctx_t*,expression_type_t,size_t);
static expression_t *new_bool_expression(parser_ctx_t*,VARIANT_BOOL);
static expression_t *new_string_expression(parser_ctx_t*,const WCHAR*);
static expression_t *new_long_expression(parser_ctx_t*,expression_type_t,LONG);
static expression_t *new_double_expression(parser_ctx_t*,double);
static expression_t *new_unary_expression(parser_ctx_t*,expression_type_t,expression_t*);
static expression_t *new_binary_expression(parser_ctx_t*,expression_type_t,expression_t*,expression_t*);
static expression_t *new_new_expression(parser_ctx_t*,const WCHAR*);

static member_expression_t *new_member_expression(parser_ctx_t*,expression_t*,const WCHAR*);

static void *new_statement(parser_ctx_t*,statement_type_t,size_t);
static statement_t *new_call_statement(parser_ctx_t*,BOOL,member_expression_t*);
static statement_t *new_assign_statement(parser_ctx_t*,member_expression_t*,expression_t*);
static statement_t *new_set_statement(parser_ctx_t*,member_expression_t*,expression_t*);
static statement_t *new_dim_statement(parser_ctx_t*,dim_decl_t*);
static statement_t *new_while_statement(parser_ctx_t*,statement_type_t,expression_t*,statement_t*);
static statement_t *new_forto_statement(parser_ctx_t*,const WCHAR*,expression_t*,expression_t*,expression_t*,statement_t*);
static statement_t *new_foreach_statement(parser_ctx_t*,const WCHAR*,expression_t*,statement_t*);
static statement_t *new_if_statement(parser_ctx_t*,expression_t*,statement_t*,elseif_decl_t*,statement_t*);
static statement_t *new_function_statement(parser_ctx_t*,function_decl_t*);
static statement_t *new_onerror_statement(parser_ctx_t*,BOOL);
static statement_t *new_const_statement(parser_ctx_t*,const_decl_t*);
static statement_t *new_select_statement(parser_ctx_t*,expression_t*,case_clausule_t*);

static dim_decl_t *new_dim_decl(parser_ctx_t*,const WCHAR*,BOOL,dim_list_t*);
static dim_list_t *new_dim(parser_ctx_t*,unsigned,dim_list_t*);
static elseif_decl_t *new_elseif_decl(parser_ctx_t*,expression_t*,statement_t*);
static function_decl_t *new_function_decl(parser_ctx_t*,const WCHAR*,function_type_t,unsigned,arg_decl_t*,statement_t*);
static arg_decl_t *new_argument_decl(parser_ctx_t*,const WCHAR*,BOOL);
static const_decl_t *new_const_decl(parser_ctx_t*,const WCHAR*,expression_t*);
static case_clausule_t *new_case_clausule(parser_ctx_t*,expression_t*,statement_t*,case_clausule_t*);

static class_decl_t *new_class_decl(parser_ctx_t*);
static class_decl_t *add_class_function(parser_ctx_t*,class_decl_t*,function_decl_t*);
static class_decl_t *add_dim_prop(parser_ctx_t*,class_decl_t*,dim_decl_t*,unsigned);

static statement_t *link_statements(statement_t*,statement_t*);

#define STORAGE_IS_PRIVATE    1
#define STORAGE_IS_DEFAULT    2

#define CHECK_ERROR if(((parser_ctx_t*)ctx)->hres != S_OK) YYABORT


#line 134 "parser.tab.c" /* yacc.c:339  */

# ifndef YY_NULLPTR
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULLPTR nullptr
#  else
#   define YY_NULLPTR 0
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif


/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int parser_debug;
#endif

/* Token type.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    tEOF = 258,
    tNL = 259,
    tREM = 260,
    tEMPTYBRACKETS = 261,
    tTRUE = 262,
    tFALSE = 263,
    tNOT = 264,
    tAND = 265,
    tOR = 266,
    tXOR = 267,
    tEQV = 268,
    tIMP = 269,
    tNEQ = 270,
    tIS = 271,
    tLTEQ = 272,
    tGTEQ = 273,
    tMOD = 274,
    tCALL = 275,
    tDIM = 276,
    tSUB = 277,
    tFUNCTION = 278,
    tGET = 279,
    tLET = 280,
    tCONST = 281,
    tIF = 282,
    tELSE = 283,
    tELSEIF = 284,
    tEND = 285,
    tTHEN = 286,
    tEXIT = 287,
    tWHILE = 288,
    tWEND = 289,
    tDO = 290,
    tLOOP = 291,
    tUNTIL = 292,
    tFOR = 293,
    tTO = 294,
    tEACH = 295,
    tIN = 296,
    tSELECT = 297,
    tCASE = 298,
    tBYREF = 299,
    tBYVAL = 300,
    tOPTION = 301,
    tSTOP = 302,
    tNOTHING = 303,
    tEMPTY = 304,
    tNULL = 305,
    tCLASS = 306,
    tSET = 307,
    tNEW = 308,
    tPUBLIC = 309,
    tPRIVATE = 310,
    tME = 311,
    tNEXT = 312,
    tON = 313,
    tRESUME = 314,
    tGOTO = 315,
    tIdentifier = 316,
    tString = 317,
    tDEFAULT = 318,
    tERROR = 319,
    tEXPLICIT = 320,
    tPROPERTY = 321,
    tSTEP = 322,
    tLong = 323,
    tShort = 324,
    tDouble = 325
  };
#endif

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED

union YYSTYPE
{
#line 86 "parser.y" /* yacc.c:355  */

    const WCHAR *string;
    statement_t *statement;
    expression_t *expression;
    member_expression_t *member;
    elseif_decl_t *elseif;
    dim_decl_t *dim_decl;
    dim_list_t *dim_list;
    function_decl_t *func_decl;
    arg_decl_t *arg_decl;
    class_decl_t *class_decl;
    const_decl_t *const_decl;
    case_clausule_t *case_clausule;
    unsigned uint;
    LONG lng;
    BOOL boolean;
    double dbl;

#line 261 "parser.tab.c" /* yacc.c:355  */
};

typedef union YYSTYPE YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif



int parser_parse (parser_ctx_t *ctx);



/* Copy the second part of user declarations.  */

#line 277 "parser.tab.c" /* yacc.c:358  */

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

#ifndef YY_ATTRIBUTE
# if (defined __GNUC__                                               \
      && (2 < __GNUC__ || (__GNUC__ == 2 && 96 <= __GNUC_MINOR__)))  \
     || defined __SUNPRO_C && 0x5110 <= __SUNPRO_C
#  define YY_ATTRIBUTE(Spec) __attribute__(Spec)
# else
#  define YY_ATTRIBUTE(Spec) /* empty */
# endif
#endif

#ifndef YY_ATTRIBUTE_PURE
# define YY_ATTRIBUTE_PURE   YY_ATTRIBUTE ((__pure__))
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# define YY_ATTRIBUTE_UNUSED YY_ATTRIBUTE ((__unused__))
#endif

#if !defined _Noreturn \
     && (!defined __STDC_VERSION__ || __STDC_VERSION__ < 201112)
# if defined _MSC_VER && 1200 <= _MSC_VER
#  define _Noreturn __declspec (noreturn)
# else
#  define _Noreturn YY_ATTRIBUTE ((__noreturn__))
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN \
    _Pragma ("GCC diagnostic push") \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")\
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif


#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYSIZE_T yynewbytes;                                            \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / sizeof (*yyptr);                          \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  5
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   965

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  87
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  60
/* YYNRULES -- Number of rules.  */
#define YYNRULES  173
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  347

/* YYTRANSLATE[YYX] -- Symbol number corresponding to YYX as returned
   by yylex, with out-of-bounds checking.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   325

#define YYTRANSLATE(YYX)                                                \
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, without out-of-bounds checking.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,    81,     2,
      76,    77,    84,    82,    75,    78,    74,    85,    73,     2,
       2,     2,     2,     2,     2,     2,     2,     2,    71,     2,
      80,    72,    79,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,    83,     2,    86,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   146,   146,   149,   150,   152,   154,   155,   158,   159,
     162,   163,   166,   169,   170,   171,   172,   173,   176,   177,
     178,   180,   181,   182,   184,   187,   190,   191,   192,   193,
     194,   195,   196,   197,   199,   200,   201,   202,   203,   205,
     207,   211,   212,   215,   216,   219,   220,   221,   224,   225,
     228,   229,   232,   235,   236,   239,   240,   243,   244,   247,
     249,   250,   253,   255,   258,   259,   262,   263,   266,   270,
     271,   274,   275,   276,   280,   281,   284,   285,   288,   289,
     290,   292,   294,   297,   298,   301,   302,   305,   306,   309,
     310,   313,   314,   317,   318,   321,   322,   325,   326,   327,
     328,   329,   330,   331,   332,   335,   336,   339,   340,   341,
     344,   345,   348,   349,   353,   354,   356,   360,   361,   364,
     365,   366,   367,   370,   371,   374,   375,   376,   377,   378,
     379,   380,   383,   384,   385,   386,   389,   390,   391,   394,
     395,   398,   401,   402,   404,   406,   407,   410,   412,   414,
     418,   420,   424,   425,   428,   429,   430,   433,   434,   437,
     438,   441,   442,   443,   447,   448,   449,   450,   451,   452,
     456,   457,   458,   459
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 0
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "tEOF", "tNL", "tREM", "tEMPTYBRACKETS",
  "tTRUE", "tFALSE", "tNOT", "tAND", "tOR", "tXOR", "tEQV", "tIMP", "tNEQ",
  "tIS", "tLTEQ", "tGTEQ", "tMOD", "tCALL", "tDIM", "tSUB", "tFUNCTION",
  "tGET", "tLET", "tCONST", "tIF", "tELSE", "tELSEIF", "tEND", "tTHEN",
  "tEXIT", "tWHILE", "tWEND", "tDO", "tLOOP", "tUNTIL", "tFOR", "tTO",
  "tEACH", "tIN", "tSELECT", "tCASE", "tBYREF", "tBYVAL", "tOPTION",
  "tSTOP", "tNOTHING", "tEMPTY", "tNULL", "tCLASS", "tSET", "tNEW",
  "tPUBLIC", "tPRIVATE", "tME", "tNEXT", "tON", "tRESUME", "tGOTO",
  "tIdentifier", "tString", "tDEFAULT", "tERROR", "tEXPLICIT", "tPROPERTY",
  "tSTEP", "tLong", "tShort", "tDouble", "':'", "'='", "'0'", "'.'", "','",
  "'('", "')'", "'-'", "'>'", "'<'", "'&'", "'+'", "'\\\\'", "'*'", "'/'",
  "'^'", "$accept", "Program", "OptionExplicit_opt", "SourceElements",
  "StatementsNl_opt", "StatementsNl", "StatementNl", "Statement",
  "SimpleStatement", "MemberExpression", "DimDeclList", "DimDecl",
  "DimList", "ConstDeclList", "ConstDecl", "ConstExpression", "DoType",
  "Step_opt", "IfStatement", "EndIf_opt", "ElseIfs_opt", "ElseIfs",
  "ElseIf", "Else_opt", "CaseClausules", "Arguments_opt",
  "ArgumentList_opt", "ArgumentList", "EmptyBrackets_opt",
  "ExpressionList", "Expression", "EqvExpression", "XorExpression",
  "OrExpression", "AndExpression", "NotExpression", "EqualityExpression",
  "ConcatExpression", "AdditiveExpression", "ModExpression",
  "IntdivExpression", "MultiplicativeExpression", "ExpExpression",
  "UnaryExpression", "CallExpression", "LiteralExpression",
  "NumericLiteralExpression", "IntegerValue", "PrimaryExpression",
  "ClassDeclaration", "ClassBody", "PropertyDecl", "FunctionDecl",
  "Storage_opt", "Storage", "ArgumentsDecl_opt", "ArgumentDeclList",
  "ArgumentDecl", "Identifier", "StSep", YY_NULLPTR
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,    58,    61,    48,    46,    44,    40,    41,    45,    62,
      60,    38,    43,    92,    42,    47,    94
};
# endif

#define YYPACT_NINF -209

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-209)))

#define YYTABLE_NINF -153

#define yytable_value_is_error(Yytable_value) \
  0

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int16 yypact[] =
{
     -23,   -16,    57,  -209,    22,  -209,   347,    22,    22,  -209,
    -209,   288,   494,   494,   557,   139,   557,    17,   148,    24,
    -209,   494,   288,    35,  -209,  -209,    52,  -209,  -209,  -209,
    -209,  -209,  -209,   649,   557,  -209,    66,    60,   442,  -209,
      32,  -209,  -209,  -209,    89,  -209,  -209,  -209,  -209,     8,
    -209,     2,     9,  -209,    64,    47,  -209,  -209,   557,  -209,
    -209,  -209,   494,  -209,  -209,  -209,  -209,  -209,   590,     8,
      21,   129,   135,   138,   143,  -209,    30,    74,   -27,   146,
      87,    91,    71,  -209,    32,  -209,  -209,  -209,  -209,  -209,
    -209,  -209,    20,  -209,  -209,   557,   697,   494,   100,   557,
      22,     8,  -209,   124,  -209,    19,  -209,   649,  -209,   475,
     475,   106,  -209,  -209,    53,     3,   494,   494,   494,   475,
     111,  -209,   494,  -209,   -10,   494,   308,  -209,  -209,  -209,
    -209,   557,   405,   557,   557,   557,   557,   590,   590,   590,
     590,   590,   590,   590,   590,   590,   590,   590,   590,   590,
     590,   590,   745,    20,   144,  -209,   649,   157,   557,    20,
      45,   127,   147,   134,  -209,  -209,  -209,   123,     6,   557,
     475,  -209,    13,    13,  -209,  -209,  -209,  -209,   133,   141,
    -209,    98,  -209,  -209,   129,   649,    92,   135,   138,   143,
    -209,    74,    74,    74,    74,    74,    74,    74,   -27,   146,
     146,    87,    91,    71,    71,  -209,   184,   697,    36,  -209,
     557,    14,   179,   494,   193,    22,    22,    38,   163,   557,
    -209,  -209,  -209,   211,  -209,   219,  -209,    22,    22,  -209,
     -10,  -209,   197,   889,   201,  -209,  -209,   194,   557,    20,
     557,   526,   212,    22,   190,    45,    45,    16,    22,   211,
     494,   494,   170,   180,   248,   793,   793,  -209,   557,   228,
    -209,   197,   227,  -209,  -209,   211,   841,    28,    22,    22,
      11,   216,    45,    22,  -209,  -209,   198,   200,   206,    45,
     248,   248,  -209,   219,  -209,   240,   241,    48,   268,   245,
    -209,  -209,   220,   557,    22,   889,   649,   557,  -209,  -209,
    -209,    13,   203,   205,  -209,  -209,  -209,  -209,   265,   270,
     284,   793,   267,  -209,   211,   841,  -209,   179,  -209,    22,
     219,   219,  -209,  -209,   649,  -209,  -209,   238,  -209,   793,
     221,   223,  -209,  -209,   266,    22,    22,   231,   793,   793,
    -209,   272,   273,   242,   244,  -209,  -209
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_uint8 yydefact[] =
{
       3,     0,     0,     5,     0,     1,   152,   170,   171,     4,
       2,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      34,     0,     0,   155,   156,   140,     0,   164,   165,   166,
     167,   168,   169,    13,     0,     6,     0,    15,    81,    22,
       0,   123,     7,    27,     0,   153,    41,   172,   173,    81,
      21,    43,    45,    37,    50,     0,   125,   126,     0,   131,
     129,   130,     0,   127,   134,   132,   135,   133,     0,    81,
       0,    85,    87,    89,    91,    93,    95,    97,   105,   107,
     110,   112,   114,   117,   120,   119,   128,    32,    30,    28,
      29,    31,     0,    55,    56,     0,   152,     0,     0,     0,
       0,    81,   154,     0,    14,     0,    12,    17,    82,     0,
       0,   124,    18,    77,    76,    78,     0,     0,     0,     0,
      19,    74,     0,    47,     0,     0,     0,    96,   121,   122,
     124,     0,   152,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   152,     0,     0,     9,    10,     0,     0,     0,
     152,   124,     0,     0,   139,    16,    80,     0,     0,     0,
       0,    42,    81,    81,    44,   138,   136,   137,     0,    48,
      51,     0,    52,    53,    86,     8,    62,    88,    90,    92,
      94,    99,   104,   103,   102,    98,   100,   101,   106,   109,
     108,   111,   113,   115,   116,   118,     0,   152,    26,    11,
       0,     0,    71,     0,     0,     0,     0,     0,   153,     0,
      35,    36,    75,    20,    79,     0,   157,     0,     0,    46,
       0,    54,    64,   152,     0,    60,    23,     0,     0,     0,
       0,     0,     0,     0,     0,   152,   152,     0,     0,    33,
       0,     0,     0,   159,    81,   152,   152,    49,     0,    69,
      65,    66,    62,    63,    24,    25,   152,    57,     0,     0,
      83,     0,   152,     0,   146,   143,     0,     0,     0,   152,
      81,    81,   158,     0,   161,     0,     0,     0,     0,     0,
      67,    61,     0,     0,     0,   152,     8,     0,    40,   145,
     141,    81,     0,     0,   144,   162,   163,   160,     0,     0,
       0,   152,     0,    39,    58,   152,    72,    71,    84,     0,
       0,     0,   150,   151,     8,    70,    59,     0,    73,   152,
       0,     0,    68,    38,     0,     0,     0,     0,   152,   152,
     147,     0,     0,     0,     0,   148,   149
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -209,  -209,  -209,  -209,  -142,  -150,   298,   -25,  -209,    -6,
     191,    93,    82,   189,  -209,  -209,   113,  -209,  -209,    65,
    -209,    58,  -209,  -209,    12,     7,  -209,   -37,   -35,    25,
     107,   199,   195,   202,   196,   -49,  -209,    97,   215,    44,
     213,   214,    42,   -57,    -4,   217,   156,  -209,  -209,  -209,
    -208,  -209,  -128,  -116,   -86,  -169,    59,  -126,    18,     5
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     2,     3,     6,   154,   155,   156,    36,    37,    69,
      50,    51,   178,    53,    54,   182,    95,   294,    39,   235,
     259,   260,   261,   289,   242,   111,   112,   167,   121,   269,
     115,    71,    72,    73,    74,    75,    76,    77,    78,    79,
      80,    81,    82,    83,    84,    85,    86,   179,    41,    42,
     214,   215,    43,    44,    45,   227,   252,   253,    46,     9
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
      38,   113,    40,   114,   228,    49,   209,    40,   104,   127,
     206,   129,    47,    48,   108,   123,   101,   131,    40,   108,
     131,     7,    96,     1,     7,   131,     7,    38,   131,    40,
      52,    55,   216,   131,   131,   131,    98,   274,   275,   100,
     276,   277,   131,   232,   217,   137,   138,   139,   140,     4,
      93,   145,   132,   240,    94,   146,   120,     5,   175,   176,
     117,   118,   131,   177,   299,   237,   213,    99,   278,    93,
     106,   304,   166,    94,   218,  -142,   130,   122,   170,   310,
     128,   170,   165,   164,   119,   124,   297,   190,     8,   225,
      38,     8,    40,     8,   205,   293,   164,   152,   102,    23,
      24,    38,   141,    40,   247,   160,   116,   186,   161,   142,
     143,   117,   118,   285,   286,   157,   103,   216,   216,   126,
     233,    70,   234,    92,   292,   -74,    38,   -74,    40,   217,
     217,   107,   319,   224,   171,   172,   173,   226,   226,   125,
      52,   105,   133,    55,   216,   316,    38,   134,    40,   135,
      38,   216,    40,   136,   317,   144,   217,   151,   207,   218,
     218,    87,    88,   217,   212,   147,    64,    65,    66,   325,
     148,    67,   158,   327,    89,   149,   150,    90,   169,    38,
     208,    40,   332,   162,   163,  -124,   218,   334,    97,   199,
     200,   203,   204,   218,   330,   331,   341,   342,   210,   219,
     222,    38,   153,    40,   220,    91,   159,   221,   262,    27,
     229,    28,    29,    30,    31,    32,   230,   168,   236,   284,
     245,   246,   241,   244,   248,   131,   258,    38,   263,    40,
     264,    52,   255,   256,   191,   192,   193,   194,   195,   196,
     197,   273,   271,   254,   266,   305,   306,   282,   272,    38,
      38,    40,    40,   279,   108,   283,   288,   234,   298,   301,
      38,   302,    40,   250,   251,   211,   226,   303,   280,   281,
     308,   309,   311,   295,   296,   312,   223,   313,   300,   320,
      27,   321,    28,    29,    30,    31,    32,   322,   324,    38,
      38,    40,    40,   323,   326,   333,   337,   340,   335,   315,
     336,   254,   343,   344,    35,    38,   243,    40,   345,    38,
     346,    40,   257,   174,   180,    56,    57,   239,    38,   290,
      40,   238,   318,    38,   329,    40,   249,   291,   187,   328,
     184,   189,    38,    38,    40,    40,   188,   231,   254,   254,
     338,   339,   307,   183,    25,   265,     0,   267,   270,    27,
      10,    28,    29,    30,    31,    32,    59,    60,    61,   198,
     201,     0,   202,     0,    34,   287,     0,    11,    12,     0,
      63,     0,     0,    13,    14,     0,    64,    65,    66,    15,
      16,    67,    17,     0,     0,    18,   181,     0,     0,    19,
       0,     0,     0,     0,    20,     0,     0,     0,    21,    22,
     314,    23,    24,    25,   270,    26,     0,     0,    27,   185,
      28,    29,    30,    31,    32,     0,     0,     0,    33,     0,
       0,     0,     0,    34,     0,    11,    12,     0,     0,     0,
       0,    13,    14,     0,     0,     0,     0,    15,    16,     0,
      17,     0,     0,    18,     0,     0,     0,    19,   108,    56,
      57,    58,    20,     0,     0,     0,     0,    22,     0,    23,
      24,    25,     0,    26,     0,     0,    27,     0,    28,    29,
      30,    31,    32,     0,     0,     0,    33,     0,     0,     0,
       0,    34,    56,    57,    58,     0,     0,     0,     0,     0,
      59,    60,    61,     0,     0,    62,     0,     0,    25,     0,
       0,     0,     0,    27,    63,    28,    29,    30,    31,    32,
      64,    65,    66,     0,     0,    67,     0,   109,   110,     0,
      68,     0,     0,    59,    60,    61,     0,     0,    62,     0,
       0,    25,     0,    56,    57,    58,    27,    63,    28,    29,
      30,    31,    32,    64,    65,    66,     0,     0,    67,     0,
     109,    34,     0,    68,   268,    27,     0,    28,    29,    30,
      31,    32,     0,     0,    56,    57,    58,     0,     0,     0,
       0,     0,     0,     0,    59,    60,    61,     0,     0,    62,
       0,     0,    25,     0,     0,     0,     0,    27,    63,    28,
      29,    30,    31,    32,    64,    65,    66,    56,    57,    67,
       0,     0,    34,     0,    68,    59,    60,    61,     0,     0,
      62,     0,     0,    25,     0,     0,     0,     0,    27,    63,
      28,    29,    30,    31,    32,    64,    65,    66,     0,     0,
      67,     0,     0,    34,     0,    68,     0,     0,    59,    60,
      61,     0,     0,    62,     0,     0,    25,     0,     0,     0,
       0,    27,    63,    28,    29,    30,    31,    32,    64,    65,
      66,     0,     0,    67,     0,     0,    34,     0,    68,    11,
      12,  -152,  -152,     0,     0,    13,    14,     0,     0,     0,
       0,    15,    16,     0,    17,     0,     0,    18,     0,     0,
       0,    19,     0,     0,     0,     0,    20,     0,     0,     0,
       0,    22,     0,    23,    24,    25,     0,    26,     0,     0,
      27,     0,    28,    29,    30,    31,    32,    11,    12,     0,
      33,     0,     0,    13,    14,    34,     0,     0,     0,    15,
      16,     0,    17,    -8,     0,    18,     0,     0,     0,    19,
       0,     0,     0,     0,    20,     0,     0,     0,     0,    22,
       0,    23,    24,    25,     0,    26,     0,     0,    27,     0,
      28,    29,    30,    31,    32,    11,    12,     0,    33,     0,
       0,    13,    14,    34,     0,     0,     0,    15,    16,    -8,
      17,     0,     0,    18,     0,     0,     0,    19,     0,     0,
       0,     0,    20,     0,     0,     0,     0,    22,     0,    23,
      24,    25,     0,    26,     0,     0,    27,     0,    28,    29,
      30,    31,    32,    11,    12,     0,    33,     0,     0,    13,
      14,    34,     0,    -8,     0,    15,    16,     0,    17,     0,
       0,    18,     0,     0,     0,    19,     0,     0,     0,     0,
      20,     0,     0,     0,     0,    22,     0,    23,    24,    25,
       0,    26,     0,     0,    27,     0,    28,    29,    30,    31,
      32,    11,    12,     0,    33,     0,     0,    13,    14,    34,
       0,     0,     0,    15,    16,     0,    17,     0,     0,    18,
       0,     0,     0,    19,     0,     0,     0,     0,    20,     0,
       0,     0,     0,    22,     0,    23,    24,    25,    -8,    26,
       0,     0,    27,     0,    28,    29,    30,    31,    32,    11,
      12,     0,    33,     0,     0,    13,    14,    34,     0,     0,
       0,    15,    16,     0,    17,     0,     0,    18,     0,     0,
       0,    19,     0,     0,     0,     0,    20,     0,     0,     0,
       0,    22,     0,    23,    24,    25,     0,    26,     0,     0,
      27,     0,    28,    29,    30,    31,    32,     0,     0,     0,
      33,     0,     0,     0,     0,    34
};

static const yytype_int16 yycheck[] =
{
       6,    38,     6,    38,   173,    11,   156,    11,    33,    58,
     152,    68,     7,     8,     6,     6,    22,    14,    22,     6,
      14,     4,    17,    46,     4,    14,     4,    33,    14,    33,
      12,    13,   160,    14,    14,    14,    18,   245,   246,    21,
      24,    25,    14,   185,   160,    15,    16,    17,    18,    65,
      33,    78,    31,    39,    37,    82,    49,     0,    68,    69,
      22,    23,    14,    73,   272,   207,    21,    43,    52,    33,
       4,   279,   109,    37,   160,    30,    69,    75,    75,    31,
      62,    75,   107,    77,    76,    76,    75,   136,    71,    76,
      96,    71,    96,    71,   151,    67,    77,    92,    63,    54,
      55,   107,    72,   107,    66,   100,    74,   132,   101,    79,
      80,    22,    23,   255,   256,    97,    64,   245,   246,    72,
      28,    14,    30,    16,   266,    72,   132,    74,   132,   245,
     246,    71,   301,   170,   116,   117,   118,   172,   173,    75,
     122,    34,    13,   125,   272,   295,   152,    12,   152,    11,
     156,   279,   156,    10,   296,    81,   272,    86,   153,   245,
     246,    22,    23,   279,   159,    19,    68,    69,    70,   311,
      83,    73,    72,   315,    35,    84,    85,    38,    72,   185,
      36,   185,   324,    59,    60,    74,   272,   329,    40,   145,
     146,   149,   150,   279,   320,   321,   338,   339,    41,    72,
      77,   207,    95,   207,    57,    66,    99,    73,   233,    61,
      77,    63,    64,    65,    66,    67,    75,   110,    34,   254,
     215,   216,    43,    30,    61,    14,    29,   233,    27,   233,
      36,   213,   227,   228,   137,   138,   139,   140,   141,   142,
     143,    51,    30,   225,   239,   280,   281,    77,   243,   255,
     256,   255,   256,   248,     6,    75,    28,    30,    42,    61,
     266,    61,   266,    44,    45,   158,   301,    61,   250,   251,
      30,    30,     4,   268,   269,    30,   169,    57,   273,    76,
      61,    76,    63,    64,    65,    66,    67,    22,     4,   295,
     296,   295,   296,    23,    27,    57,    30,    66,    77,   294,
      77,   283,    30,    30,     6,   311,   213,   311,    66,   315,
      66,   315,   230,   122,   125,     7,     8,   210,   324,   261,
     324,   208,   297,   329,   319,   329,   219,   262,   133,   317,
     131,   135,   338,   339,   338,   339,   134,   181,   320,   321,
     335,   336,   283,   126,    56,   238,    -1,   240,   241,    61,
       3,    63,    64,    65,    66,    67,    48,    49,    50,   144,
     147,    -1,   148,    -1,    76,   258,    -1,    20,    21,    -1,
      62,    -1,    -1,    26,    27,    -1,    68,    69,    70,    32,
      33,    73,    35,    -1,    -1,    38,    78,    -1,    -1,    42,
      -1,    -1,    -1,    -1,    47,    -1,    -1,    -1,    51,    52,
     293,    54,    55,    56,   297,    58,    -1,    -1,    61,     4,
      63,    64,    65,    66,    67,    -1,    -1,    -1,    71,    -1,
      -1,    -1,    -1,    76,    -1,    20,    21,    -1,    -1,    -1,
      -1,    26,    27,    -1,    -1,    -1,    -1,    32,    33,    -1,
      35,    -1,    -1,    38,    -1,    -1,    -1,    42,     6,     7,
       8,     9,    47,    -1,    -1,    -1,    -1,    52,    -1,    54,
      55,    56,    -1,    58,    -1,    -1,    61,    -1,    63,    64,
      65,    66,    67,    -1,    -1,    -1,    71,    -1,    -1,    -1,
      -1,    76,     7,     8,     9,    -1,    -1,    -1,    -1,    -1,
      48,    49,    50,    -1,    -1,    53,    -1,    -1,    56,    -1,
      -1,    -1,    -1,    61,    62,    63,    64,    65,    66,    67,
      68,    69,    70,    -1,    -1,    73,    -1,    75,    76,    -1,
      78,    -1,    -1,    48,    49,    50,    -1,    -1,    53,    -1,
      -1,    56,    -1,     7,     8,     9,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    -1,    -1,    73,    -1,
      75,    76,    -1,    78,    28,    61,    -1,    63,    64,    65,
      66,    67,    -1,    -1,     7,     8,     9,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    48,    49,    50,    -1,    -1,    53,
      -1,    -1,    56,    -1,    -1,    -1,    -1,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,     7,     8,    73,
      -1,    -1,    76,    -1,    78,    48,    49,    50,    -1,    -1,
      53,    -1,    -1,    56,    -1,    -1,    -1,    -1,    61,    62,
      63,    64,    65,    66,    67,    68,    69,    70,    -1,    -1,
      73,    -1,    -1,    76,    -1,    78,    -1,    -1,    48,    49,
      50,    -1,    -1,    53,    -1,    -1,    56,    -1,    -1,    -1,
      -1,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    -1,    -1,    73,    -1,    -1,    76,    -1,    78,    20,
      21,    22,    23,    -1,    -1,    26,    27,    -1,    -1,    -1,
      -1,    32,    33,    -1,    35,    -1,    -1,    38,    -1,    -1,
      -1,    42,    -1,    -1,    -1,    -1,    47,    -1,    -1,    -1,
      -1,    52,    -1,    54,    55,    56,    -1,    58,    -1,    -1,
      61,    -1,    63,    64,    65,    66,    67,    20,    21,    -1,
      71,    -1,    -1,    26,    27,    76,    -1,    -1,    -1,    32,
      33,    -1,    35,    36,    -1,    38,    -1,    -1,    -1,    42,
      -1,    -1,    -1,    -1,    47,    -1,    -1,    -1,    -1,    52,
      -1,    54,    55,    56,    -1,    58,    -1,    -1,    61,    -1,
      63,    64,    65,    66,    67,    20,    21,    -1,    71,    -1,
      -1,    26,    27,    76,    -1,    -1,    -1,    32,    33,    34,
      35,    -1,    -1,    38,    -1,    -1,    -1,    42,    -1,    -1,
      -1,    -1,    47,    -1,    -1,    -1,    -1,    52,    -1,    54,
      55,    56,    -1,    58,    -1,    -1,    61,    -1,    63,    64,
      65,    66,    67,    20,    21,    -1,    71,    -1,    -1,    26,
      27,    76,    -1,    30,    -1,    32,    33,    -1,    35,    -1,
      -1,    38,    -1,    -1,    -1,    42,    -1,    -1,    -1,    -1,
      47,    -1,    -1,    -1,    -1,    52,    -1,    54,    55,    56,
      -1,    58,    -1,    -1,    61,    -1,    63,    64,    65,    66,
      67,    20,    21,    -1,    71,    -1,    -1,    26,    27,    76,
      -1,    -1,    -1,    32,    33,    -1,    35,    -1,    -1,    38,
      -1,    -1,    -1,    42,    -1,    -1,    -1,    -1,    47,    -1,
      -1,    -1,    -1,    52,    -1,    54,    55,    56,    57,    58,
      -1,    -1,    61,    -1,    63,    64,    65,    66,    67,    20,
      21,    -1,    71,    -1,    -1,    26,    27,    76,    -1,    -1,
      -1,    32,    33,    -1,    35,    -1,    -1,    38,    -1,    -1,
      -1,    42,    -1,    -1,    -1,    -1,    47,    -1,    -1,    -1,
      -1,    52,    -1,    54,    55,    56,    -1,    58,    -1,    -1,
      61,    -1,    63,    64,    65,    66,    67,    -1,    -1,    -1,
      71,    -1,    -1,    -1,    -1,    76
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,    46,    88,    89,    65,     0,    90,     4,    71,   146,
       3,    20,    21,    26,    27,    32,    33,    35,    38,    42,
      47,    51,    52,    54,    55,    56,    58,    61,    63,    64,
      65,    66,    67,    71,    76,    93,    94,    95,    96,   105,
     131,   135,   136,   139,   140,   141,   145,   146,   146,    96,
      97,    98,   145,   100,   101,   145,     7,     8,     9,    48,
      49,    50,    53,    62,    68,    69,    70,    73,    78,    96,
     117,   118,   119,   120,   121,   122,   123,   124,   125,   126,
     127,   128,   129,   130,   131,   132,   133,    22,    23,    35,
      38,    66,   117,    33,    37,   103,   146,    40,   145,    43,
     145,    96,    63,    64,    94,   117,     4,    71,     6,    75,
      76,   112,   113,   114,   115,   117,    74,    22,    23,    76,
     112,   115,    75,     6,    76,    75,    72,   122,   145,   130,
     112,    14,    31,    13,    12,    11,    10,    15,    16,    17,
      18,    72,    79,    80,    81,    78,    82,    19,    83,    84,
      85,    86,   146,   117,    91,    92,    93,   145,    72,   117,
     146,   112,    59,    60,    77,    94,   114,   114,   117,    72,
      75,   145,   145,   145,    97,    68,    69,    73,    99,   134,
     100,    78,   102,   132,   118,     4,    94,   119,   120,   121,
     122,   124,   124,   124,   124,   124,   124,   124,   125,   126,
     126,   127,   128,   129,   129,   130,    91,   146,    36,    92,
      41,   117,   146,    21,   137,   138,   139,   140,   141,    72,
      57,    73,    77,   117,   114,    76,   115,   142,   142,    77,
      75,   133,    91,    28,    30,   106,    34,    91,   103,   117,
      39,    43,   111,    98,    30,   146,   146,    66,    61,   117,
      44,    45,   143,   144,   145,   146,   146,    99,    29,   107,
     108,   109,    94,    27,    36,   117,   146,   117,    28,   116,
     117,    30,   146,    51,   137,   137,    24,    25,    52,   146,
     145,   145,    77,    75,   115,    91,    91,   117,    28,   110,
     108,   106,    91,    67,   104,   146,   146,    75,    42,   137,
     146,    61,    61,    61,   137,   115,   115,   143,    30,    30,
      31,     4,    30,    57,   117,   146,    92,    91,   116,   142,
      76,    76,    22,    23,     4,    91,    27,    91,   111,   146,
     144,   144,    91,    57,    91,    77,    77,    30,   146,   146,
      66,    91,    91,    30,    30,    66,    66
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,    87,    88,    89,    89,    90,    90,    90,    91,    91,
      92,    92,    93,    94,    94,    94,    94,    94,    95,    95,
      95,    95,    95,    95,    95,    95,    95,    95,    95,    95,
      95,    95,    95,    95,    95,    95,    95,    95,    95,    95,
      95,    96,    96,    97,    97,    98,    98,    98,    99,    99,
     100,   100,   101,   102,   102,   103,   103,   104,   104,   105,
     105,   105,   106,   106,   107,   107,   108,   108,   109,   110,
     110,   111,   111,   111,   112,   112,   113,   113,   114,   114,
     114,   115,   115,   116,   116,   117,   117,   118,   118,   119,
     119,   120,   120,   121,   121,   122,   122,   123,   123,   123,
     123,   123,   123,   123,   123,   124,   124,   125,   125,   125,
     126,   126,   127,   127,   128,   128,   128,   129,   129,   130,
     130,   130,   130,   131,   131,   132,   132,   132,   132,   132,
     132,   132,   133,   133,   133,   133,   134,   134,   134,   135,
     135,   136,   137,   137,   137,   137,   137,   138,   138,   138,
     139,   139,   140,   140,   141,   141,   141,   142,   142,   143,
     143,   144,   144,   144,   145,   145,   145,   145,   145,   145,
     146,   146,   146,   146
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     3,     0,     3,     0,     2,     2,     0,     1,
       1,     2,     2,     1,     2,     1,     3,     2,     2,     3,
       4,     2,     1,     5,     6,     6,     4,     1,     2,     2,
       2,     2,     2,     5,     1,     4,     4,     2,    10,     8,
       7,     1,     3,     1,     3,     1,     4,     2,     1,     3,
       1,     3,     3,     1,     2,     1,     1,     0,     2,     9,
       5,     7,     0,     2,     0,     1,     1,     2,     5,     0,
       3,     0,     4,     5,     1,     3,     1,     1,     1,     3,
       2,     0,     1,     1,     3,     1,     3,     1,     3,     1,
       3,     1,     3,     1,     3,     1,     2,     1,     3,     3,
       3,     3,     3,     3,     3,     1,     3,     1,     3,     3,
       1,     3,     1,     3,     1,     3,     3,     1,     3,     1,
       1,     2,     2,     1,     2,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     3,
       1,     7,     0,     3,     4,     4,     3,     9,    11,    11,
       8,     8,     0,     1,     2,     1,     1,     1,     3,     1,
       3,     2,     3,     3,     1,     1,     1,     1,     1,     1,
       1,     1,     2,     2
};


#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)
#define YYEMPTY         (-2)
#define YYEOF           0

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                  \
do                                                              \
  if (yychar == YYEMPTY)                                        \
    {                                                           \
      yychar = (Token);                                         \
      yylval = (Value);                                         \
      YYPOPSTACK (yylen);                                       \
      yystate = *yyssp;                                         \
      goto yybackup;                                            \
    }                                                           \
  else                                                          \
    {                                                           \
      yyerror (ctx, YY_("syntax error: cannot back up")); \
      YYERROR;                                                  \
    }                                                           \
while (0)

/* Error token number */
#define YYTERROR        1
#define YYERRCODE       256



/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)

/* This macro is provided for backward compatibility. */
#ifndef YY_LOCATION_PRINT
# define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#endif


# define YY_SYMBOL_PRINT(Title, Type, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Type, Value, ctx); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*----------------------------------------.
| Print this symbol's value on YYOUTPUT.  |
`----------------------------------------*/

static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, parser_ctx_t *ctx)
{
  FILE *yyo = yyoutput;
  YYUSE (yyo);
  YYUSE (ctx);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
  YYUSE (yytype);
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, parser_ctx_t *ctx)
{
  YYFPRINTF (yyoutput, "%s %s (",
             yytype < YYNTOKENS ? "token" : "nterm", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep, ctx);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yytype_int16 *yyssp, YYSTYPE *yyvsp, int yyrule, parser_ctx_t *ctx)
{
  unsigned long int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       yystos[yyssp[yyi + 1 - yynrhs]],
                       &(yyvsp[(yyi + 1) - (yynrhs)])
                                              , ctx);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule, ctx); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
yystrlen (const char *yystr)
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            /* Fall through.  */
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULLPTR, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYSIZE_T yysize1 = yysize + yytnamerr (YY_NULLPTR, yytname[yyx]);
                  if (! (yysize <= yysize1
                         && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                    return 2;
                  yysize = yysize1;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
    default: /* Avoid compiler warnings. */
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    YYSIZE_T yysize1 = yysize + yystrlen (yyformat);
    if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
      return 2;
    yysize = yysize1;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep, parser_ctx_t *ctx)
{
  YYUSE (yyvaluep);
  YYUSE (ctx);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yytype);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}




/*----------.
| yyparse.  |
`----------*/

int
yyparse (parser_ctx_t *ctx)
{
/* The lookahead symbol.  */
int yychar;


/* The semantic value of the lookahead symbol.  */
/* Default value used for initialization, for pacifying older GCCs
   or non-GCC compilers.  */
YY_INITIAL_VALUE (static YYSTYPE yyval_default;)
YYSTYPE yylval YY_INITIAL_VALUE (= yyval_default);

    /* Number of syntax errors so far.  */
    int yynerrs;

    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       'yyss': related to states.
       'yyvs': related to semantic values.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        YYSTYPE *yyvs1 = yyvs;
        yytype_int16 *yyss1 = yyss;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * sizeof (*yyssp),
                    &yyvs1, yysize * sizeof (*yyvsp),
                    &yystacksize);

        yyss = yyss1;
        yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yytype_int16 *yyss1 = yyss;
        union yyalloc *yyptr =
          (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
                  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = yylex (&yylval, ctx);
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:
#line 146 "parser.y" /* yacc.c:1648  */
    { parse_complete(ctx, (yyvsp[-2].boolean)); }
#line 1744 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 3:
#line 149 "parser.y" /* yacc.c:1648  */
    { (yyval.boolean) = FALSE; }
#line 1750 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 4:
#line 150 "parser.y" /* yacc.c:1648  */
    { (yyval.boolean) = TRUE; }
#line 1756 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 6:
#line 154 "parser.y" /* yacc.c:1648  */
    { source_add_statement(ctx, (yyvsp[0].statement)); }
#line 1762 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 7:
#line 155 "parser.y" /* yacc.c:1648  */
    { source_add_class(ctx, (yyvsp[0].class_decl)); }
#line 1768 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 8:
#line 158 "parser.y" /* yacc.c:1648  */
    { (yyval.statement) = NULL; }
#line 1774 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 9:
#line 159 "parser.y" /* yacc.c:1648  */
    { (yyval.statement) = (yyvsp[0].statement); }
#line 1780 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 10:
#line 162 "parser.y" /* yacc.c:1648  */
    { (yyval.statement) = (yyvsp[0].statement); }
#line 1786 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 11:
#line 163 "parser.y" /* yacc.c:1648  */
    { (yyval.statement) = link_statements((yyvsp[-1].statement), (yyvsp[0].statement)); }
#line 1792 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 12:
#line 166 "parser.y" /* yacc.c:1648  */
    { (yyval.statement) = (yyvsp[-1].statement); }
#line 1798 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 13:
#line 169 "parser.y" /* yacc.c:1648  */
    { (yyval.statement) = NULL; }
#line 1804 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 14:
#line 170 "parser.y" /* yacc.c:1648  */
    { (yyval.statement) = (yyvsp[0].statement); }
#line 1810 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 15:
#line 171 "parser.y" /* yacc.c:1648  */
    { (yyval.statement) = (yyvsp[0].statement); }
#line 1816 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 16:
#line 172 "parser.y" /* yacc.c:1648  */
    { (yyvsp[-2].statement)->next = (yyvsp[0].statement); (yyval.statement) = (yyvsp[-2].statement); }
#line 1822 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 17:
#line 173 "parser.y" /* yacc.c:1648  */
    { (yyval.statement) = (yyvsp[-1].statement); }
#line 1828 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 18:
#line 176 "parser.y" /* yacc.c:1648  */
    { (yyvsp[-1].member)->args = (yyvsp[0].expression); (yyval.statement) = new_call_statement(ctx, FALSE, (yyvsp[-1].member)); CHECK_ERROR; }
#line 1834 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 19:
#line 177 "parser.y" /* yacc.c:1648  */
    { (yyvsp[-1].member)->args = (yyvsp[0].expression); (yyval.statement) = new_call_statement(ctx, TRUE, (yyvsp[-1].member)); CHECK_ERROR; }
#line 1840 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 20:
#line 179 "parser.y" /* yacc.c:1648  */
    { (yyvsp[-3].member)->args = (yyvsp[-2].expression); (yyval.statement) = new_assign_statement(ctx, (yyvsp[-3].member), (yyvsp[0].expression)); CHECK_ERROR; }
#line 1846 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 21:
#line 180 "parser.y" /* yacc.c:1648  */
    { (yyval.statement) = new_dim_statement(ctx, (yyvsp[0].dim_decl)); CHECK_ERROR; }
#line 1852 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 22:
#line 181 "parser.y" /* yacc.c:1648  */
    { (yyval.statement) = (yyvsp[0].statement); }
#line 1858 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 23:
#line 183 "parser.y" /* yacc.c:1648  */
    { (yyval.statement) = new_while_statement(ctx, STAT_WHILE, (yyvsp[-3].expression), (yyvsp[-1].statement)); CHECK_ERROR; }
#line 1864 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 24:
#line 185 "parser.y" /* yacc.c:1648  */
    { (yyval.statement) = new_while_statement(ctx, (yyvsp[-4].boolean) ? STAT_WHILELOOP : STAT_UNTIL, (yyvsp[-3].expression), (yyvsp[-1].statement));
                                              CHECK_ERROR; }
#line 1871 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 25:
#line 188 "parser.y" /* yacc.c:1648  */
    { (yyval.statement) = new_while_statement(ctx, (yyvsp[-1].boolean) ? STAT_DOWHILE : STAT_DOUNTIL, (yyvsp[0].expression), (yyvsp[-3].statement));
                                              CHECK_ERROR; }
#line 1878 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 26:
#line 190 "parser.y" /* yacc.c:1648  */
    { (yyval.statement) = new_while_statement(ctx, STAT_DOWHILE, NULL, (yyvsp[-1].statement)); CHECK_ERROR; }
#line 1884 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 27:
#line 191 "parser.y" /* yacc.c:1648  */
    { (yyval.statement) = new_function_statement(ctx, (yyvsp[0].func_decl)); CHECK_ERROR; }
#line 1890 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 28:
#line 192 "parser.y" /* yacc.c:1648  */
    { (yyval.statement) = new_statement(ctx, STAT_EXITDO, 0); CHECK_ERROR; }
#line 1896 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 29:
#line 193 "parser.y" /* yacc.c:1648  */
    { (yyval.statement) = new_statement(ctx, STAT_EXITFOR, 0); CHECK_ERROR; }
#line 1902 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 30:
#line 194 "parser.y" /* yacc.c:1648  */
    { (yyval.statement) = new_statement(ctx, STAT_EXITFUNC, 0); CHECK_ERROR; }
#line 1908 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 31:
#line 195 "parser.y" /* yacc.c:1648  */
    { (yyval.statement) = new_statement(ctx, STAT_EXITPROP, 0); CHECK_ERROR; }
#line 1914 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 32:
#line 196 "parser.y" /* yacc.c:1648  */
    { (yyval.statement) = new_statement(ctx, STAT_EXITSUB, 0); CHECK_ERROR; }
#line 1920 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 33:
#line 198 "parser.y" /* yacc.c:1648  */
    { (yyvsp[-3].member)->args = (yyvsp[-2].expression); (yyval.statement) = new_set_statement(ctx, (yyvsp[-3].member), (yyvsp[0].expression)); CHECK_ERROR; }
#line 1926 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 34:
#line 199 "parser.y" /* yacc.c:1648  */
    { (yyval.statement) = new_statement(ctx, STAT_STOP, 0); CHECK_ERROR; }
#line 1932 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 35:
#line 200 "parser.y" /* yacc.c:1648  */
    { (yyval.statement) = new_onerror_statement(ctx, TRUE); CHECK_ERROR; }
#line 1938 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 36:
#line 201 "parser.y" /* yacc.c:1648  */
    { (yyval.statement) = new_onerror_statement(ctx, FALSE); CHECK_ERROR; }
#line 1944 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 37:
#line 202 "parser.y" /* yacc.c:1648  */
    { (yyval.statement) = new_const_statement(ctx, (yyvsp[0].const_decl)); CHECK_ERROR; }
#line 1950 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 38:
#line 204 "parser.y" /* yacc.c:1648  */
    { (yyval.statement) = new_forto_statement(ctx, (yyvsp[-8].string), (yyvsp[-6].expression), (yyvsp[-4].expression), (yyvsp[-3].expression), (yyvsp[-1].statement)); CHECK_ERROR; }
#line 1956 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 39:
#line 206 "parser.y" /* yacc.c:1648  */
    { (yyval.statement) = new_foreach_statement(ctx, (yyvsp[-5].string), (yyvsp[-3].expression), (yyvsp[-1].statement)); }
#line 1962 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 40:
#line 208 "parser.y" /* yacc.c:1648  */
    { (yyval.statement) = new_select_statement(ctx, (yyvsp[-4].expression), (yyvsp[-2].case_clausule)); }
#line 1968 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 41:
#line 211 "parser.y" /* yacc.c:1648  */
    { (yyval.member) = new_member_expression(ctx, NULL, (yyvsp[0].string)); CHECK_ERROR; }
#line 1974 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 42:
#line 212 "parser.y" /* yacc.c:1648  */
    { (yyval.member) = new_member_expression(ctx, (yyvsp[-2].expression), (yyvsp[0].string)); CHECK_ERROR; }
#line 1980 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 43:
#line 215 "parser.y" /* yacc.c:1648  */
    { (yyval.dim_decl) = (yyvsp[0].dim_decl); }
#line 1986 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 44:
#line 216 "parser.y" /* yacc.c:1648  */
    { (yyvsp[-2].dim_decl)->next = (yyvsp[0].dim_decl); (yyval.dim_decl) = (yyvsp[-2].dim_decl); }
#line 1992 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 45:
#line 219 "parser.y" /* yacc.c:1648  */
    { (yyval.dim_decl) = new_dim_decl(ctx, (yyvsp[0].string), FALSE, NULL); CHECK_ERROR; }
#line 1998 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 46:
#line 220 "parser.y" /* yacc.c:1648  */
    { (yyval.dim_decl) = new_dim_decl(ctx, (yyvsp[-3].string), TRUE, (yyvsp[-1].dim_list)); CHECK_ERROR; }
#line 2004 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 47:
#line 221 "parser.y" /* yacc.c:1648  */
    { (yyval.dim_decl) = new_dim_decl(ctx, (yyvsp[-1].string), TRUE, NULL); CHECK_ERROR; }
#line 2010 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 48:
#line 224 "parser.y" /* yacc.c:1648  */
    { (yyval.dim_list) = new_dim(ctx, (yyvsp[0].uint), NULL); }
#line 2016 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 49:
#line 225 "parser.y" /* yacc.c:1648  */
    { (yyval.dim_list) = new_dim(ctx, (yyvsp[-2].uint), (yyvsp[0].dim_list)); }
#line 2022 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 50:
#line 228 "parser.y" /* yacc.c:1648  */
    { (yyval.const_decl) = (yyvsp[0].const_decl); }
#line 2028 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 51:
#line 229 "parser.y" /* yacc.c:1648  */
    { (yyvsp[-2].const_decl)->next = (yyvsp[0].const_decl); (yyval.const_decl) = (yyvsp[-2].const_decl); }
#line 2034 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 52:
#line 232 "parser.y" /* yacc.c:1648  */
    { (yyval.const_decl) = new_const_decl(ctx, (yyvsp[-2].string), (yyvsp[0].expression)); CHECK_ERROR; }
#line 2040 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 53:
#line 235 "parser.y" /* yacc.c:1648  */
    { (yyval.expression) = (yyvsp[0].expression); }
#line 2046 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 54:
#line 236 "parser.y" /* yacc.c:1648  */
    { (yyval.expression) = new_unary_expression(ctx, EXPR_NEG, (yyvsp[0].expression)); CHECK_ERROR; }
#line 2052 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 55:
#line 239 "parser.y" /* yacc.c:1648  */
    { (yyval.boolean) = TRUE; }
#line 2058 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 56:
#line 240 "parser.y" /* yacc.c:1648  */
    { (yyval.boolean) = FALSE; }
#line 2064 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 57:
#line 243 "parser.y" /* yacc.c:1648  */
    { (yyval.expression) = NULL;}
#line 2070 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 58:
#line 244 "parser.y" /* yacc.c:1648  */
    { (yyval.expression) = (yyvsp[0].expression); }
#line 2076 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 59:
#line 248 "parser.y" /* yacc.c:1648  */
    { (yyval.statement) = new_if_statement(ctx, (yyvsp[-7].expression), (yyvsp[-4].statement), (yyvsp[-3].elseif), (yyvsp[-2].statement)); CHECK_ERROR; }
#line 2082 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 60:
#line 249 "parser.y" /* yacc.c:1648  */
    { (yyval.statement) = new_if_statement(ctx, (yyvsp[-3].expression), (yyvsp[-1].statement), NULL, NULL); CHECK_ERROR; }
#line 2088 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 61:
#line 251 "parser.y" /* yacc.c:1648  */
    { (yyval.statement) = new_if_statement(ctx, (yyvsp[-5].expression), (yyvsp[-3].statement), NULL, (yyvsp[-1].statement)); CHECK_ERROR; }
#line 2094 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 64:
#line 258 "parser.y" /* yacc.c:1648  */
    { (yyval.elseif) = NULL; }
#line 2100 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 65:
#line 259 "parser.y" /* yacc.c:1648  */
    { (yyval.elseif) = (yyvsp[0].elseif); }
#line 2106 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 66:
#line 262 "parser.y" /* yacc.c:1648  */
    { (yyval.elseif) = (yyvsp[0].elseif); }
#line 2112 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 67:
#line 263 "parser.y" /* yacc.c:1648  */
    { (yyvsp[-1].elseif)->next = (yyvsp[0].elseif); (yyval.elseif) = (yyvsp[-1].elseif); }
#line 2118 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 68:
#line 267 "parser.y" /* yacc.c:1648  */
    { (yyval.elseif) = new_elseif_decl(ctx, (yyvsp[-3].expression), (yyvsp[0].statement)); }
#line 2124 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 69:
#line 270 "parser.y" /* yacc.c:1648  */
    { (yyval.statement) = NULL; }
#line 2130 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 70:
#line 271 "parser.y" /* yacc.c:1648  */
    { (yyval.statement) = (yyvsp[0].statement); }
#line 2136 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 71:
#line 274 "parser.y" /* yacc.c:1648  */
    { (yyval.case_clausule) = NULL; }
#line 2142 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 72:
#line 275 "parser.y" /* yacc.c:1648  */
    { (yyval.case_clausule) = new_case_clausule(ctx, NULL, (yyvsp[0].statement), NULL); }
#line 2148 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 73:
#line 277 "parser.y" /* yacc.c:1648  */
    { (yyval.case_clausule) = new_case_clausule(ctx, (yyvsp[-3].expression), (yyvsp[-1].statement), (yyvsp[0].case_clausule)); }
#line 2154 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 74:
#line 280 "parser.y" /* yacc.c:1648  */
    { (yyval.expression) = NULL; }
#line 2160 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 75:
#line 281 "parser.y" /* yacc.c:1648  */
    { (yyval.expression) = (yyvsp[-1].expression); }
#line 2166 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 76:
#line 284 "parser.y" /* yacc.c:1648  */
    { (yyval.expression) = NULL; }
#line 2172 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 77:
#line 285 "parser.y" /* yacc.c:1648  */
    { (yyval.expression) = (yyvsp[0].expression); }
#line 2178 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 78:
#line 288 "parser.y" /* yacc.c:1648  */
    { (yyval.expression) = (yyvsp[0].expression); }
#line 2184 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 79:
#line 289 "parser.y" /* yacc.c:1648  */
    { (yyvsp[-2].expression)->next = (yyvsp[0].expression); (yyval.expression) = (yyvsp[-2].expression); }
#line 2190 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 80:
#line 290 "parser.y" /* yacc.c:1648  */
    { (yyval.expression) = new_expression(ctx, EXPR_NOARG, 0); CHECK_ERROR; (yyval.expression)->next = (yyvsp[0].expression); }
#line 2196 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 83:
#line 297 "parser.y" /* yacc.c:1648  */
    { (yyval.expression) = (yyvsp[0].expression); }
#line 2202 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 84:
#line 298 "parser.y" /* yacc.c:1648  */
    { (yyvsp[-2].expression)->next = (yyvsp[0].expression); (yyval.expression) = (yyvsp[-2].expression); }
#line 2208 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 85:
#line 301 "parser.y" /* yacc.c:1648  */
    { (yyval.expression) = (yyvsp[0].expression); }
#line 2214 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 86:
#line 302 "parser.y" /* yacc.c:1648  */
    { (yyval.expression) = new_binary_expression(ctx, EXPR_IMP, (yyvsp[-2].expression), (yyvsp[0].expression)); CHECK_ERROR; }
#line 2220 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 87:
#line 305 "parser.y" /* yacc.c:1648  */
    { (yyval.expression) = (yyvsp[0].expression); }
#line 2226 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 88:
#line 306 "parser.y" /* yacc.c:1648  */
    { (yyval.expression) = new_binary_expression(ctx, EXPR_EQV, (yyvsp[-2].expression), (yyvsp[0].expression)); CHECK_ERROR; }
#line 2232 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 89:
#line 309 "parser.y" /* yacc.c:1648  */
    { (yyval.expression) = (yyvsp[0].expression); }
#line 2238 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 90:
#line 310 "parser.y" /* yacc.c:1648  */
    { (yyval.expression) = new_binary_expression(ctx, EXPR_XOR, (yyvsp[-2].expression), (yyvsp[0].expression)); CHECK_ERROR; }
#line 2244 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 91:
#line 313 "parser.y" /* yacc.c:1648  */
    { (yyval.expression) = (yyvsp[0].expression); }
#line 2250 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 92:
#line 314 "parser.y" /* yacc.c:1648  */
    { (yyval.expression) = new_binary_expression(ctx, EXPR_OR, (yyvsp[-2].expression), (yyvsp[0].expression)); CHECK_ERROR; }
#line 2256 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 93:
#line 317 "parser.y" /* yacc.c:1648  */
    { (yyval.expression) = (yyvsp[0].expression); }
#line 2262 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 94:
#line 318 "parser.y" /* yacc.c:1648  */
    { (yyval.expression) = new_binary_expression(ctx, EXPR_AND, (yyvsp[-2].expression), (yyvsp[0].expression)); CHECK_ERROR; }
#line 2268 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 95:
#line 321 "parser.y" /* yacc.c:1648  */
    { (yyval.expression) = (yyvsp[0].expression); }
#line 2274 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 96:
#line 322 "parser.y" /* yacc.c:1648  */
    { (yyval.expression) = new_unary_expression(ctx, EXPR_NOT, (yyvsp[0].expression)); CHECK_ERROR; }
#line 2280 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 97:
#line 325 "parser.y" /* yacc.c:1648  */
    { (yyval.expression) = (yyvsp[0].expression); }
#line 2286 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 98:
#line 326 "parser.y" /* yacc.c:1648  */
    { (yyval.expression) = new_binary_expression(ctx, EXPR_EQUAL, (yyvsp[-2].expression), (yyvsp[0].expression)); CHECK_ERROR; }
#line 2292 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 99:
#line 327 "parser.y" /* yacc.c:1648  */
    { (yyval.expression) = new_binary_expression(ctx, EXPR_NEQUAL, (yyvsp[-2].expression), (yyvsp[0].expression)); CHECK_ERROR; }
#line 2298 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 100:
#line 328 "parser.y" /* yacc.c:1648  */
    { (yyval.expression) = new_binary_expression(ctx, EXPR_GT, (yyvsp[-2].expression), (yyvsp[0].expression)); CHECK_ERROR; }
#line 2304 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 101:
#line 329 "parser.y" /* yacc.c:1648  */
    { (yyval.expression) = new_binary_expression(ctx, EXPR_LT, (yyvsp[-2].expression), (yyvsp[0].expression)); CHECK_ERROR; }
#line 2310 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 102:
#line 330 "parser.y" /* yacc.c:1648  */
    { (yyval.expression) = new_binary_expression(ctx, EXPR_GTEQ, (yyvsp[-2].expression), (yyvsp[0].expression)); CHECK_ERROR; }
#line 2316 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 103:
#line 331 "parser.y" /* yacc.c:1648  */
    { (yyval.expression) = new_binary_expression(ctx, EXPR_LTEQ, (yyvsp[-2].expression), (yyvsp[0].expression)); CHECK_ERROR; }
#line 2322 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 104:
#line 332 "parser.y" /* yacc.c:1648  */
    { (yyval.expression) = new_binary_expression(ctx, EXPR_IS, (yyvsp[-2].expression), (yyvsp[0].expression)); CHECK_ERROR; }
#line 2328 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 105:
#line 335 "parser.y" /* yacc.c:1648  */
    { (yyval.expression) = (yyvsp[0].expression); }
#line 2334 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 106:
#line 336 "parser.y" /* yacc.c:1648  */
    { (yyval.expression) = new_binary_expression(ctx, EXPR_CONCAT, (yyvsp[-2].expression), (yyvsp[0].expression)); CHECK_ERROR; }
#line 2340 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 107:
#line 339 "parser.y" /* yacc.c:1648  */
    { (yyval.expression) = (yyvsp[0].expression); }
#line 2346 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 108:
#line 340 "parser.y" /* yacc.c:1648  */
    { (yyval.expression) = new_binary_expression(ctx, EXPR_ADD, (yyvsp[-2].expression), (yyvsp[0].expression)); CHECK_ERROR; }
#line 2352 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 109:
#line 341 "parser.y" /* yacc.c:1648  */
    { (yyval.expression) = new_binary_expression(ctx, EXPR_SUB, (yyvsp[-2].expression), (yyvsp[0].expression)); CHECK_ERROR; }
#line 2358 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 110:
#line 344 "parser.y" /* yacc.c:1648  */
    { (yyval.expression) = (yyvsp[0].expression); }
#line 2364 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 111:
#line 345 "parser.y" /* yacc.c:1648  */
    { (yyval.expression) = new_binary_expression(ctx, EXPR_MOD, (yyvsp[-2].expression), (yyvsp[0].expression)); CHECK_ERROR; }
#line 2370 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 112:
#line 348 "parser.y" /* yacc.c:1648  */
    { (yyval.expression) = (yyvsp[0].expression); }
#line 2376 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 113:
#line 350 "parser.y" /* yacc.c:1648  */
    { (yyval.expression) = new_binary_expression(ctx, EXPR_IDIV, (yyvsp[-2].expression), (yyvsp[0].expression)); CHECK_ERROR; }
#line 2382 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 114:
#line 353 "parser.y" /* yacc.c:1648  */
    { (yyval.expression) = (yyvsp[0].expression); }
#line 2388 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 115:
#line 355 "parser.y" /* yacc.c:1648  */
    { (yyval.expression) = new_binary_expression(ctx, EXPR_MUL, (yyvsp[-2].expression), (yyvsp[0].expression)); CHECK_ERROR; }
#line 2394 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 116:
#line 357 "parser.y" /* yacc.c:1648  */
    { (yyval.expression) = new_binary_expression(ctx, EXPR_DIV, (yyvsp[-2].expression), (yyvsp[0].expression)); CHECK_ERROR; }
#line 2400 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 117:
#line 360 "parser.y" /* yacc.c:1648  */
    { (yyval.expression) = (yyvsp[0].expression); }
#line 2406 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 118:
#line 361 "parser.y" /* yacc.c:1648  */
    { (yyval.expression) = new_binary_expression(ctx, EXPR_EXP, (yyvsp[-2].expression), (yyvsp[0].expression)); CHECK_ERROR; }
#line 2412 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 119:
#line 364 "parser.y" /* yacc.c:1648  */
    { (yyval.expression) = (yyvsp[0].expression); }
#line 2418 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 120:
#line 365 "parser.y" /* yacc.c:1648  */
    { (yyval.expression) = (yyvsp[0].expression); }
#line 2424 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 121:
#line 366 "parser.y" /* yacc.c:1648  */
    { (yyval.expression) = new_new_expression(ctx, (yyvsp[0].string)); CHECK_ERROR; }
#line 2430 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 122:
#line 367 "parser.y" /* yacc.c:1648  */
    { (yyval.expression) = new_unary_expression(ctx, EXPR_NEG, (yyvsp[0].expression)); CHECK_ERROR; }
#line 2436 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 123:
#line 370 "parser.y" /* yacc.c:1648  */
    { (yyval.expression) = (yyvsp[0].expression); }
#line 2442 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 124:
#line 371 "parser.y" /* yacc.c:1648  */
    { (yyvsp[-1].member)->args = (yyvsp[0].expression); (yyval.expression) = &(yyvsp[-1].member)->expr; }
#line 2448 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 125:
#line 374 "parser.y" /* yacc.c:1648  */
    { (yyval.expression) = new_bool_expression(ctx, VARIANT_TRUE); CHECK_ERROR; }
#line 2454 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 126:
#line 375 "parser.y" /* yacc.c:1648  */
    { (yyval.expression) = new_bool_expression(ctx, VARIANT_FALSE); CHECK_ERROR; }
#line 2460 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 127:
#line 376 "parser.y" /* yacc.c:1648  */
    { (yyval.expression) = new_string_expression(ctx, (yyvsp[0].string)); CHECK_ERROR; }
#line 2466 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 128:
#line 377 "parser.y" /* yacc.c:1648  */
    { (yyval.expression) = (yyvsp[0].expression); }
#line 2472 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 129:
#line 378 "parser.y" /* yacc.c:1648  */
    { (yyval.expression) = new_expression(ctx, EXPR_EMPTY, 0); CHECK_ERROR; }
#line 2478 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 130:
#line 379 "parser.y" /* yacc.c:1648  */
    { (yyval.expression) = new_expression(ctx, EXPR_NULL, 0); CHECK_ERROR; }
#line 2484 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 131:
#line 380 "parser.y" /* yacc.c:1648  */
    { (yyval.expression) = new_expression(ctx, EXPR_NOTHING, 0); CHECK_ERROR; }
#line 2490 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 132:
#line 383 "parser.y" /* yacc.c:1648  */
    { (yyval.expression) = new_long_expression(ctx, EXPR_USHORT, (yyvsp[0].lng)); CHECK_ERROR; }
#line 2496 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 133:
#line 384 "parser.y" /* yacc.c:1648  */
    { (yyval.expression) = new_long_expression(ctx, EXPR_USHORT, 0); CHECK_ERROR; }
#line 2502 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 134:
#line 385 "parser.y" /* yacc.c:1648  */
    { (yyval.expression) = new_long_expression(ctx, EXPR_ULONG, (yyvsp[0].lng)); CHECK_ERROR; }
#line 2508 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 135:
#line 386 "parser.y" /* yacc.c:1648  */
    { (yyval.expression) = new_double_expression(ctx, (yyvsp[0].dbl)); CHECK_ERROR; }
#line 2514 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 136:
#line 389 "parser.y" /* yacc.c:1648  */
    { (yyval.uint) = (yyvsp[0].lng); }
#line 2520 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 137:
#line 390 "parser.y" /* yacc.c:1648  */
    { (yyval.uint) = 0; }
#line 2526 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 138:
#line 391 "parser.y" /* yacc.c:1648  */
    { (yyval.uint) = (yyvsp[0].lng); }
#line 2532 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 139:
#line 394 "parser.y" /* yacc.c:1648  */
    { (yyval.expression) = new_unary_expression(ctx, EXPR_BRACKETS, (yyvsp[-1].expression)); }
#line 2538 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 140:
#line 395 "parser.y" /* yacc.c:1648  */
    { (yyval.expression) = new_expression(ctx, EXPR_ME, 0); CHECK_ERROR; }
#line 2544 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 141:
#line 398 "parser.y" /* yacc.c:1648  */
    { (yyvsp[-3].class_decl)->name = (yyvsp[-5].string); (yyval.class_decl) = (yyvsp[-3].class_decl); }
#line 2550 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 142:
#line 401 "parser.y" /* yacc.c:1648  */
    { (yyval.class_decl) = new_class_decl(ctx); }
#line 2556 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 143:
#line 402 "parser.y" /* yacc.c:1648  */
    { (yyval.class_decl) = add_class_function(ctx, (yyvsp[0].class_decl), (yyvsp[-2].func_decl)); CHECK_ERROR; }
#line 2562 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 144:
#line 404 "parser.y" /* yacc.c:1648  */
    { dim_decl_t *dim_decl = new_dim_decl(ctx, (yyvsp[-2].string), FALSE, NULL); CHECK_ERROR;
                                                  (yyval.class_decl) = add_dim_prop(ctx, (yyvsp[0].class_decl), dim_decl, (yyvsp[-3].uint)); CHECK_ERROR; }
#line 2569 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 145:
#line 406 "parser.y" /* yacc.c:1648  */
    { (yyval.class_decl) = add_dim_prop(ctx, (yyvsp[0].class_decl), (yyvsp[-2].dim_decl), 0); CHECK_ERROR; }
#line 2575 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 146:
#line 407 "parser.y" /* yacc.c:1648  */
    { (yyval.class_decl) = add_class_function(ctx, (yyvsp[0].class_decl), (yyvsp[-2].func_decl)); CHECK_ERROR; }
#line 2581 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 147:
#line 411 "parser.y" /* yacc.c:1648  */
    { (yyval.func_decl) = new_function_decl(ctx, (yyvsp[-5].string), FUNC_PROPGET, (yyvsp[-8].uint), (yyvsp[-4].arg_decl), (yyvsp[-2].statement)); CHECK_ERROR; }
#line 2587 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 148:
#line 413 "parser.y" /* yacc.c:1648  */
    { (yyval.func_decl) = new_function_decl(ctx, (yyvsp[-7].string), FUNC_PROPLET, (yyvsp[-10].uint), (yyvsp[-5].arg_decl), (yyvsp[-2].statement)); CHECK_ERROR; }
#line 2593 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 149:
#line 415 "parser.y" /* yacc.c:1648  */
    { (yyval.func_decl) = new_function_decl(ctx, (yyvsp[-7].string), FUNC_PROPSET, (yyvsp[-10].uint), (yyvsp[-5].arg_decl), (yyvsp[-2].statement)); CHECK_ERROR; }
#line 2599 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 150:
#line 419 "parser.y" /* yacc.c:1648  */
    { (yyval.func_decl) = new_function_decl(ctx, (yyvsp[-5].string), FUNC_SUB, (yyvsp[-7].uint), (yyvsp[-4].arg_decl), (yyvsp[-2].statement)); CHECK_ERROR; }
#line 2605 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 151:
#line 421 "parser.y" /* yacc.c:1648  */
    { (yyval.func_decl) = new_function_decl(ctx, (yyvsp[-5].string), FUNC_FUNCTION, (yyvsp[-7].uint), (yyvsp[-4].arg_decl), (yyvsp[-2].statement)); CHECK_ERROR; }
#line 2611 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 152:
#line 424 "parser.y" /* yacc.c:1648  */
    { (yyval.uint) = 0; }
#line 2617 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 153:
#line 425 "parser.y" /* yacc.c:1648  */
    { (yyval.uint) = (yyvsp[0].uint); }
#line 2623 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 154:
#line 428 "parser.y" /* yacc.c:1648  */
    { (yyval.uint) = STORAGE_IS_DEFAULT; }
#line 2629 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 155:
#line 429 "parser.y" /* yacc.c:1648  */
    { (yyval.uint) = 0; }
#line 2635 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 156:
#line 430 "parser.y" /* yacc.c:1648  */
    { (yyval.uint) = STORAGE_IS_PRIVATE; }
#line 2641 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 157:
#line 433 "parser.y" /* yacc.c:1648  */
    { (yyval.arg_decl) = NULL; }
#line 2647 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 158:
#line 434 "parser.y" /* yacc.c:1648  */
    { (yyval.arg_decl) = (yyvsp[-1].arg_decl); }
#line 2653 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 159:
#line 437 "parser.y" /* yacc.c:1648  */
    { (yyval.arg_decl) = (yyvsp[0].arg_decl); }
#line 2659 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 160:
#line 438 "parser.y" /* yacc.c:1648  */
    { (yyvsp[-2].arg_decl)->next = (yyvsp[0].arg_decl); (yyval.arg_decl) = (yyvsp[-2].arg_decl); }
#line 2665 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 161:
#line 441 "parser.y" /* yacc.c:1648  */
    { (yyval.arg_decl) = new_argument_decl(ctx, (yyvsp[-1].string), TRUE); }
#line 2671 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 162:
#line 442 "parser.y" /* yacc.c:1648  */
    { (yyval.arg_decl) = new_argument_decl(ctx, (yyvsp[-1].string), TRUE); }
#line 2677 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 163:
#line 443 "parser.y" /* yacc.c:1648  */
    { (yyval.arg_decl) = new_argument_decl(ctx, (yyvsp[-1].string), FALSE); }
#line 2683 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 164:
#line 447 "parser.y" /* yacc.c:1648  */
    { (yyval.string) = (yyvsp[0].string); }
#line 2689 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 165:
#line 448 "parser.y" /* yacc.c:1648  */
    { (yyval.string) = (yyvsp[0].string); }
#line 2695 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 166:
#line 449 "parser.y" /* yacc.c:1648  */
    { (yyval.string) = (yyvsp[0].string); }
#line 2701 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 167:
#line 450 "parser.y" /* yacc.c:1648  */
    { (yyval.string) = (yyvsp[0].string); }
#line 2707 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 168:
#line 451 "parser.y" /* yacc.c:1648  */
    { (yyval.string) = (yyvsp[0].string); }
#line 2713 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 169:
#line 452 "parser.y" /* yacc.c:1648  */
    { (yyval.string) = (yyvsp[0].string); }
#line 2719 "parser.tab.c" /* yacc.c:1648  */
    break;


#line 2723 "parser.tab.c" /* yacc.c:1648  */
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (ctx, YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (ctx, yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval, ctx);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYTERROR;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  yystos[yystate], yyvsp, ctx);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (ctx, YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval, ctx);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  yystos[*yyssp], yyvsp, ctx);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  return yyresult;
}
#line 461 "parser.y" /* yacc.c:1907  */


static int parser_error(parser_ctx_t *ctx, const char *str)
{
    return 0;
}

static void source_add_statement(parser_ctx_t *ctx, statement_t *stat)
{
    if(!stat)
        return;

    if(ctx->stats) {
        ctx->stats_tail->next = stat;
        ctx->stats_tail = stat;
    }else {
        ctx->stats = ctx->stats_tail = stat;
    }
}

static void source_add_class(parser_ctx_t *ctx, class_decl_t *class_decl)
{
    class_decl->next = ctx->class_decls;
    ctx->class_decls = class_decl;
}

static void parse_complete(parser_ctx_t *ctx, BOOL option_explicit)
{
    ctx->parse_complete = TRUE;
    ctx->option_explicit = option_explicit;
}

static void *new_expression(parser_ctx_t *ctx, expression_type_t type, size_t size)
{
    expression_t *expr;

    expr = parser_alloc(ctx, size ? size : sizeof(*expr));
    if(expr) {
        expr->type = type;
        expr->next = NULL;
    }

    return expr;
}

static expression_t *new_bool_expression(parser_ctx_t *ctx, VARIANT_BOOL value)
{
    bool_expression_t *expr;

    expr = new_expression(ctx, EXPR_BOOL, sizeof(*expr));
    if(!expr)
        return NULL;

    expr->value = value;
    return &expr->expr;
}

static expression_t *new_string_expression(parser_ctx_t *ctx, const WCHAR *value)
{
    string_expression_t *expr;

    expr = new_expression(ctx, EXPR_STRING, sizeof(*expr));
    if(!expr)
        return NULL;

    expr->value = value;
    return &expr->expr;
}

static expression_t *new_long_expression(parser_ctx_t *ctx, expression_type_t type, LONG value)
{
    int_expression_t *expr;

    expr = new_expression(ctx, type, sizeof(*expr));
    if(!expr)
        return NULL;

    expr->value = value;
    return &expr->expr;
}

static expression_t *new_double_expression(parser_ctx_t *ctx, double value)
{
    double_expression_t *expr;

    expr = new_expression(ctx, EXPR_DOUBLE, sizeof(*expr));
    if(!expr)
        return NULL;

    expr->value = value;
    return &expr->expr;
}

static expression_t *new_unary_expression(parser_ctx_t *ctx, expression_type_t type, expression_t *subexpr)
{
    unary_expression_t *expr;

    expr = new_expression(ctx, type, sizeof(*expr));
    if(!expr)
        return NULL;

    expr->subexpr = subexpr;
    return &expr->expr;
}

static expression_t *new_binary_expression(parser_ctx_t *ctx, expression_type_t type, expression_t *left, expression_t *right)
{
    binary_expression_t *expr;

    expr = new_expression(ctx, type, sizeof(*expr));
    if(!expr)
        return NULL;

    expr->left = left;
    expr->right = right;
    return &expr->expr;
}

static member_expression_t *new_member_expression(parser_ctx_t *ctx, expression_t *obj_expr, const WCHAR *identifier)
{
    member_expression_t *expr;

    expr = new_expression(ctx, EXPR_MEMBER, sizeof(*expr));
    if(!expr)
        return NULL;

    expr->obj_expr = obj_expr;
    expr->identifier = identifier;
    expr->args = NULL;
    return expr;
}

static expression_t *new_new_expression(parser_ctx_t *ctx, const WCHAR *identifier)
{
    string_expression_t *expr;

    expr = new_expression(ctx, EXPR_NEW, sizeof(*expr));
    if(!expr)
        return NULL;

    expr->value = identifier;
    return &expr->expr;
}

static void *new_statement(parser_ctx_t *ctx, statement_type_t type, size_t size)
{
    statement_t *stat;

    stat = parser_alloc(ctx, size ? size : sizeof(*stat));
    if(stat) {
        stat->type = type;
        stat->next = NULL;
    }

    return stat;
}

static statement_t *new_call_statement(parser_ctx_t *ctx, BOOL is_strict, member_expression_t *expr)
{
    call_statement_t *stat;

    stat = new_statement(ctx, STAT_CALL, sizeof(*stat));
    if(!stat)
        return NULL;

    stat->expr = expr;
    stat->is_strict = is_strict;
    return &stat->stat;
}

static statement_t *new_assign_statement(parser_ctx_t *ctx, member_expression_t *left, expression_t *right)
{
    assign_statement_t *stat;

    stat = new_statement(ctx, STAT_ASSIGN, sizeof(*stat));
    if(!stat)
        return NULL;

    stat->member_expr = left;
    stat->value_expr = right;
    return &stat->stat;
}

static statement_t *new_set_statement(parser_ctx_t *ctx, member_expression_t *left, expression_t *right)
{
    assign_statement_t *stat;

    stat = new_statement(ctx, STAT_SET, sizeof(*stat));
    if(!stat)
        return NULL;

    stat->member_expr = left;
    stat->value_expr = right;
    return &stat->stat;
}

static dim_decl_t *new_dim_decl(parser_ctx_t *ctx, const WCHAR *name, BOOL is_array, dim_list_t *dims)
{
    dim_decl_t *decl;

    decl = parser_alloc(ctx, sizeof(*decl));
    if(!decl)
        return NULL;

    decl->name = name;
    decl->is_array = is_array;
    decl->dims = dims;
    decl->next = NULL;
    return decl;
}

static dim_list_t *new_dim(parser_ctx_t *ctx, unsigned val, dim_list_t *next)
{
    dim_list_t *ret;

    ret = parser_alloc(ctx, sizeof(*ret));
    if(!ret)
        return NULL;

    ret->val = val;
    ret->next = next;
    return ret;
}

static statement_t *new_dim_statement(parser_ctx_t *ctx, dim_decl_t *decls)
{
    dim_statement_t *stat;

    stat = new_statement(ctx, STAT_DIM, sizeof(*stat));
    if(!stat)
        return NULL;

    stat->dim_decls = decls;
    return &stat->stat;
}

static elseif_decl_t *new_elseif_decl(parser_ctx_t *ctx, expression_t *expr, statement_t *stat)
{
    elseif_decl_t *decl;

    decl = parser_alloc(ctx, sizeof(*decl));
    if(!decl)
        return NULL;

    decl->expr = expr;
    decl->stat = stat;
    decl->next = NULL;
    return decl;
}

static statement_t *new_while_statement(parser_ctx_t *ctx, statement_type_t type, expression_t *expr, statement_t *body)
{
    while_statement_t *stat;

    stat = new_statement(ctx, type, sizeof(*stat));
    if(!stat)
        return NULL;

    stat->expr = expr;
    stat->body = body;
    return &stat->stat;
}

static statement_t *new_forto_statement(parser_ctx_t *ctx, const WCHAR *identifier, expression_t *from_expr,
        expression_t *to_expr, expression_t *step_expr, statement_t *body)
{
    forto_statement_t *stat;

    stat = new_statement(ctx, STAT_FORTO, sizeof(*stat));
    if(!stat)
        return NULL;

    stat->identifier = identifier;
    stat->from_expr = from_expr;
    stat->to_expr = to_expr;
    stat->step_expr = step_expr;
    stat->body = body;
    return &stat->stat;
}

static statement_t *new_foreach_statement(parser_ctx_t *ctx, const WCHAR *identifier, expression_t *group_expr,
        statement_t *body)
{
    foreach_statement_t *stat;

    stat = new_statement(ctx, STAT_FOREACH, sizeof(*stat));
    if(!stat)
        return NULL;

    stat->identifier = identifier;
    stat->group_expr = group_expr;
    stat->body = body;
    return &stat->stat;
}

static statement_t *new_if_statement(parser_ctx_t *ctx, expression_t *expr, statement_t *if_stat, elseif_decl_t *elseif_decl,
        statement_t *else_stat)
{
    if_statement_t *stat;

    stat = new_statement(ctx, STAT_IF, sizeof(*stat));
    if(!stat)
        return NULL;

    stat->expr = expr;
    stat->if_stat = if_stat;
    stat->elseifs = elseif_decl;
    stat->else_stat = else_stat;
    return &stat->stat;
}

static statement_t *new_select_statement(parser_ctx_t *ctx, expression_t *expr, case_clausule_t *case_clausules)
{
    select_statement_t *stat;

    stat = new_statement(ctx, STAT_SELECT, sizeof(*stat));
    if(!stat)
        return NULL;

    stat->expr = expr;
    stat->case_clausules = case_clausules;
    return &stat->stat;
}

static case_clausule_t *new_case_clausule(parser_ctx_t *ctx, expression_t *expr, statement_t *stat, case_clausule_t *next)
{
    case_clausule_t *ret;

    ret = parser_alloc(ctx, sizeof(*ret));
    if(!ret)
        return NULL;

    ret->expr = expr;
    ret->stat = stat;
    ret->next = next;
    return ret;
}

static statement_t *new_onerror_statement(parser_ctx_t *ctx, BOOL resume_next)
{
    onerror_statement_t *stat;

    stat = new_statement(ctx, STAT_ONERROR, sizeof(*stat));
    if(!stat)
        return NULL;

    stat->resume_next = resume_next;
    return &stat->stat;
}

static arg_decl_t *new_argument_decl(parser_ctx_t *ctx, const WCHAR *name, BOOL by_ref)
{
    arg_decl_t *arg_decl;

    arg_decl = parser_alloc(ctx, sizeof(*arg_decl));
    if(!arg_decl)
        return NULL;

    arg_decl->name = name;
    arg_decl->by_ref = by_ref;
    arg_decl->next = NULL;
    return arg_decl;
}

static function_decl_t *new_function_decl(parser_ctx_t *ctx, const WCHAR *name, function_type_t type,
        unsigned storage_flags, arg_decl_t *arg_decl, statement_t *body)
{
    function_decl_t *decl;

    if(storage_flags & STORAGE_IS_DEFAULT) {
        if(type == FUNC_PROPGET) {
            type = FUNC_DEFGET;
        }else {
            FIXME("Invalid default property\n");
            ctx->hres = E_FAIL;
            return NULL;
        }
    }

    decl = parser_alloc(ctx, sizeof(*decl));
    if(!decl)
        return NULL;

    decl->name = name;
    decl->type = type;
    decl->is_public = !(storage_flags & STORAGE_IS_PRIVATE);
    decl->args = arg_decl;
    decl->body = body;
    decl->next = NULL;
    decl->next_prop_func = NULL;
    return decl;
}

static statement_t *new_function_statement(parser_ctx_t *ctx, function_decl_t *decl)
{
    function_statement_t *stat;

    stat = new_statement(ctx, STAT_FUNC, sizeof(*stat));
    if(!stat)
        return NULL;

    stat->func_decl = decl;
    return &stat->stat;
}

static class_decl_t *new_class_decl(parser_ctx_t *ctx)
{
    class_decl_t *class_decl;

    class_decl = parser_alloc(ctx, sizeof(*class_decl));
    if(!class_decl)
        return NULL;

    class_decl->funcs = NULL;
    class_decl->props = NULL;
    class_decl->next = NULL;
    return class_decl;
}

static class_decl_t *add_class_function(parser_ctx_t *ctx, class_decl_t *class_decl, function_decl_t *decl)
{
    function_decl_t *iter;

    for(iter = class_decl->funcs; iter; iter = iter->next) {
        if(!strcmpiW(iter->name, decl->name)) {
            if(decl->type == FUNC_SUB || decl->type == FUNC_FUNCTION) {
                FIXME("Redefinition of %s::%s\n", debugstr_w(class_decl->name), debugstr_w(decl->name));
                ctx->hres = E_FAIL;
                return NULL;
            }

            while(1) {
                if(iter->type == decl->type) {
                    FIXME("Redefinition of %s::%s\n", debugstr_w(class_decl->name), debugstr_w(decl->name));
                    ctx->hres = E_FAIL;
                    return NULL;
                }
                if(!iter->next_prop_func)
                    break;
                iter = iter->next_prop_func;
            }

            iter->next_prop_func = decl;
            return class_decl;
        }
    }

    decl->next = class_decl->funcs;
    class_decl->funcs = decl;
    return class_decl;
}

static class_decl_t *add_dim_prop(parser_ctx_t *ctx, class_decl_t *class_decl, dim_decl_t *dim_decl, unsigned storage_flags)
{
    if(storage_flags & STORAGE_IS_DEFAULT) {
        FIXME("variant prop van't be default value\n");
        ctx->hres = E_FAIL;
        return NULL;
    }

    dim_decl->is_public = !(storage_flags & STORAGE_IS_PRIVATE);
    dim_decl->next = class_decl->props;
    class_decl->props = dim_decl;
    return class_decl;
}

static const_decl_t *new_const_decl(parser_ctx_t *ctx, const WCHAR *name, expression_t *expr)
{
    const_decl_t *decl;

    decl = parser_alloc(ctx, sizeof(*decl));
    if(!decl)
        return NULL;

    decl->name = name;
    decl->value_expr = expr;
    decl->next = NULL;
    return decl;
}

static statement_t *new_const_statement(parser_ctx_t *ctx, const_decl_t *decls)
{
    const_statement_t *stat;

    stat = new_statement(ctx, STAT_CONST, sizeof(*stat));
    if(!stat)
        return NULL;

    stat->decls = decls;
    return &stat->stat;
}

static statement_t *link_statements(statement_t *head, statement_t *tail)
{
    statement_t *iter;

    for(iter = head; iter->next; iter = iter->next);
    iter->next = tail;

    return head;
}

void *parser_alloc(parser_ctx_t *ctx, size_t size)
{
    void *ret;

    ret = heap_pool_alloc(&ctx->heap, size);
    if(!ret)
        ctx->hres = E_OUTOFMEMORY;
    return ret;
}

HRESULT parse_script(parser_ctx_t *ctx, const WCHAR *code, const WCHAR *delimiter)
{
    static const WCHAR html_delimiterW[] = {'<','/','s','c','r','i','p','t','>',0};

    ctx->code = ctx->ptr = code;
    ctx->end = ctx->code + strlenW(ctx->code);

    heap_pool_init(&ctx->heap);

    ctx->parse_complete = FALSE;
    ctx->hres = S_OK;

    ctx->last_token = tNL;
    ctx->last_nl = 0;
    ctx->stats = ctx->stats_tail = NULL;
    ctx->class_decls = NULL;
    ctx->option_explicit = FALSE;
    ctx->is_html = delimiter && !strcmpiW(delimiter, html_delimiterW);

    parser_parse(ctx);

    if(FAILED(ctx->hres))
        return ctx->hres;
    if(!ctx->parse_complete) {
        FIXME("parser failed around %s\n", debugstr_w(ctx->code+20 > ctx->ptr ? ctx->code : ctx->ptr-20));
        return E_FAIL;
    }

    return S_OK;
}

void parser_release(parser_ctx_t *ctx)
{
    heap_pool_free(&ctx->heap);
}
